org.apache.bcel.classfile

## Class ConstantString

- java.lang.Object
- - org.apache.bcel.classfile.Constant
  - - org.apache.bcel.classfile.ConstantString

- All Implemented Interfaces:
    Cloneable, ConstantObject, Node

      public final class ConstantString
      extends Constant
      implements ConstantObject

  This class is derived from the abstract `Constant` and represents a reference to a String object.
  Version:
    $Id: ConstantString.java 1806200 2017-08-25 16:33:06Z ggregory $
  See Also:
    `Constant`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Constant

      `tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConstantString(ConstantString c)` Initialize from another object.
    `ConstantString(int string_index)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class.
    `void` | `dump(DataOutputStream file)` Dump constant field reference to file stream in binary format.
    `String` | `getBytes(ConstantPool cp)`
    `Object` | `getConstantValue(ConstantPool cp)`
    `int` | `getStringIndex()`
    `void` | `setStringIndex(int string_index)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Constant

      `clone, copy, equals, getComparator, getTag, hashCode, readConstant, setComparator`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ConstantString

          public ConstantString(ConstantString c)

      Initialize from another object.

    - #### ConstantString

          public ConstantString(int string_index)

      Parameters:
        `string_index` - Index of Constant_Utf8 in constant pool

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Constant`
      Parameters:
        `v` - Visitor object

    - #### dump

          public final void dump(DataOutputStream file)
                          throws IOException

      Dump constant field reference to file stream in binary format.
      Specified by:
        `dump` in class `Constant`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException`

    - #### getStringIndex

          public final int getStringIndex()

      Returns:
        Index in constant pool of the string (ConstantUtf8).

    - #### setStringIndex

          public final void setStringIndex(int string_index)

      Parameters:
        `string_index` - the index into the constant of the string value

    - #### toString

          public final String toString()

      Overrides:
        `toString` in class `Constant`
      Returns:
        String representation.

    - #### getConstantValue

          public Object getConstantValue(ConstantPool cp)

      Specified by:
        `getConstantValue` in interface `ConstantObject`
      Returns:
        String object

    - #### getBytes

          public String getBytes(ConstantPool cp)

      Returns:
        dereferenced string

Copyright © 2004–2017 The Apache Software Foundation. All rights reserved.